JUCE: TracktionMarketplaceStatus Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
TracktionMarketplaceStatus Class Reference
juce_product_unlocking » marketplace

An implementation of the OnlineUnlockStatus class which talks to the Tracktion Marketplace server. More...

`#include <juce_TracktionMarketplaceStatus.h>`

Inheritance diagram for TracktionMarketplaceStatus:

## Public Member Functions
| TracktionMarketplaceStatus ()
bool | doesProductIDMatch (const String &returnedIDFromServer) override
| This must check whether a product ID string that the server returned is OK for unlocking the current app.
URL | getServerAuthenticationURL () override
| Returns the URL of the authentication API.
String | getWebsiteName () override
| Returns the name of the web-store website, not for communication, but for presenting to the user.
String | readReplyFromWebserver (const String &email, const String &password) override
| Subclasses that talk to a particular web-store will implement this method to contact their webserver and attempt to unlock the current machine for the given username and password.
void | userCancelled () override
| This method will be called if the user cancels the connection to the webserver by clicking the cancel button in OnlineUnlockForm::OverlayComp.
Public Member Functions inherited from OnlineUnlockStatus
| OnlineUnlockStatus ()
virtual | ~OnlineUnlockStatus ()
| Destructor.
virtual String | getProductID ()=0
| This must return your product's ID, as allocated by the store.
virtual RSAKey | getPublicKey ()=0
| This must return the RSA public key for authenticating responses from the server for this app.
virtual void | saveState (const String &)=0
| This method must store the given string somewhere in your app's persistent properties, so it can be retrieved later by getState().
virtual String | getState ()=0
| This method must retrieve the last state that was provided by the saveState method.
virtual StringArray | getLocalMachineIDs ()
| Returns a list of strings, any of which should be unique to this physical computer.
virtual String | getMessageForConnectionFailure (bool isInternetConnectionWorking)
virtual String | getMessageForUnexpectedReply ()
var | isUnlocked () const
| Returns true if the product has been successfully authorised for this machine.
Time | getExpiryTime () const
| Returns the Time when the keyfile expires.
void | setUserEmail (const String &usernameOrEmail)
| Optionally allows the app to provide the user's email address if it is known.
String | getUserEmail () const
| Returns the user's email address if known.
Result | applyKeyFile (const String &keyFileContent)
| Attempts to perform an unlock using a block of key-file data provided.
UnlockResult | attemptWebserverUnlock (const String &email, const String &password)
| Contacts the webserver and attempts to perform a registration with the given user details.
void | load ()
| Attempts to load the status from the state retrieved by getState().
void | save ()
| Triggers a call to saveState which you can use to store the current unlock status in your app's settings.

## Detailed Description

An implementation of the OnlineUnlockStatus class which talks to the Tracktion Marketplace server.

For details about how to use this class, see the docs for the base class: OnlineUnlockStatus. Basically, you need to inherit from it, and implement all the pure virtual methods to tell it about your product.

See also
  OnlineUnlockStatus, OnlineUnlockForm, KeyGeneration

## Constructor & Destructor Documentation

## ◆ TracktionMarketplaceStatus()

TracktionMarketplaceStatus::TracktionMarketplaceStatus | ( |  | ) |

## Member Function Documentation

## ◆ doesProductIDMatch()

bool TracktionMarketplaceStatus::doesProductIDMatch | ( | const String & | returnedIDFromServer | ) |
| overridevirtual

This must check whether a product ID string that the server returned is OK for unlocking the current app.

Implements OnlineUnlockStatus.

## ◆ getServerAuthenticationURL()

URL TracktionMarketplaceStatus::getServerAuthenticationURL | ( |  | ) |
| overridevirtual

Returns the URL of the authentication API.

Implements OnlineUnlockStatus.

## ◆ getWebsiteName()

String TracktionMarketplaceStatus::getWebsiteName | ( |  | ) |
| overridevirtual

Returns the name of the web-store website, not for communication, but for presenting to the user.

Implements OnlineUnlockStatus.

## ◆ readReplyFromWebserver()

String TracktionMarketplaceStatus::readReplyFromWebserver | ( | const String & | email,
|  | const String & | password
| ) |  |
| overridevirtual

Subclasses that talk to a particular web-store will implement this method to contact their webserver and attempt to unlock the current machine for the given username and password.

The return value is the XML text from the server which contains error information and/or the encrypted keyfile.

Implements OnlineUnlockStatus.

## ◆ userCancelled()

void TracktionMarketplaceStatus::userCancelled | ( |  | ) |
| overridevirtual

This method will be called if the user cancels the connection to the webserver by clicking the cancel button in OnlineUnlockForm::OverlayComp.

The default implementation of this method does nothing but you should use it to cancel any WebInputStreams that may be connecting.

Reimplemented from OnlineUnlockStatus.

The documentation for this class was generated from the following file:

- juce_TracktionMarketplaceStatus.h